  /* 4 SET POINT,  INPUT SELECTION THROUGH LINKS, ROOMTEMP COMPENSATION */
             /*  PROGRAMMABLE FORMAT FOR mA & VOLT I/P   */
   /* extended the array length for arrk[28] instead of arrk[27] 29/03/04*/
      /*   9/12/03  12:20 RD0 for 3rd relay & RD1 for 4th relay  */
                     /*   UNIVERSAL INPUT   */
               /* WITH SQROOT FACILITY   */
               /*IMPROVED RESPONSE TIME , LINEARITY RTD,THURMOCOUPLE*/
               /*IC : PIC16F877A	*/
	       /*NAGARAJU R. 25-7-2007	*/


#include "xc.h"
//#include "pic16f877a.h"
static __bank2  unsigned char dgtno , gformat , str[6] , kcnt , kfnd , kcode , calcflag;
static __bank1  unsigned char chn , convcomp , intrcnt1 , intrcnt2 , adcflg , frmflg,rtflag1 ;
int  sample[5],nsamp ,rtadj,roomcnt;            
static __bank2 int temp ;
const int *cntptr ;
unsigned int chksum,roomtmp ;
char under , over , rlystat , asize , rtflg ,outflg ,dcpt,prcs;
static __bank2 int idlvolt ;
static __bank1 int  x1 , x2 , y1 , y2 , x ; 
static __bank1 int  volt,idlzr,idlsp;            //roomcnt ;
static __bank1 int  span,sp1,sp2,adczr,adcsp,hyst,sp3 ,sp4;
static __bank1 char rlytp,typ,frmt ;
static __bank1 unsigned char conv;      //roomtmp ;
static __bank1 int  cnt4ma , cnt20ma  ;
static __bank1 int  pwmduty;
static __bank1 char pwmflag ;
static __bank1 unsigned char addr ;

static __bank2 int zero,rt;
static __bank3 unsigned char copy , goodcopy ;
static __bank3 unsigned int achksum[ 4 ] ;

/*static bank2 long iopden ,iincnum,iinc,iopnum ;*/

#define   FUN    0
#define   INC    3
#define   SFT    2
#define   ENT    1

#define   ATMN   5
#define   DCR    8
/*

#define   ATMN   0
#define   ENT    5
#define   INC    3
#define   SFT    1

#define   DCR    2
#define   FUN    8
*/
const char dgttab[6] = { 0x1, 0x2, 0x4, 0x8, 0x10, 0x20 } ;
const int arrj[ 18 ] = { -452, -237, 0000,  252,  514,  782,
                         1052, 1323, 1594, 1864, 2133, 2402,
                         2674, 2950, 3231, 3521, 3820, 4127 } ;
                            /* -100 to 750 J TYPE */

const int arrk[ 28 ] = { -347, -184, 0000,  197,  400,  599,
                          794,  991, 1192, 1395, 1601, 1808,
                         2015, 2223, 2431, 2638, 2844, 3047,
                         3248, 3447, 3644, 3838, 4029, 4218,
                         4404, 4588, 4766, 6000 } ;
                            /* -100 to 1200 K TYPE */

const int arrr[ 20 ]  = { -440, -220, 0,  217,  431,  641,
                          848, 1052, 1252, 1450, 1643, 1833,
                          2020, 2203, 2383, 2560, 2735, 2905,
                          3070, 3230
                       } ;
                           /* -100 TO 850 RTD */

const unsigned char seg7[48]=
{ 
 /*    0 ,    1 ,    2 ,    3 ,    4 ,    5 ,    6 ,    7 ,    8 ,    9 , */ 
   0x03 , 0x9f , 0x25 , 0x0d , 0x99 , 0x49 , 0x41 , 0x1f , 0x01 , 0x09 , 
 /* after 9 gap of  7 is left because of the gap in ASCII character set   */
 /* blank,minus,minus1, gap  ,  gap ,?mark ,  gap ,    A ,    B ,    C ,  */
   0xff , 0xfd , 0x9d , 0xff , 0xff , 0x35 , 0xff , 0x11 , 0xc1 , 0x63 ,
 /*    D ,    E ,    F ,    G ,    H ,    I ,    J ,    K ,    L ,    M , */
   0x85 , 0x61 , 0x71 , 0x09 , 0x91 , 0x9f , 0x8f , 0xa1 , 0xe3 , 0x55 , 
 /*    N ,    O ,    P ,    Q ,    R ,    S ,    T ,    U ,    V ,    W , */
   0xd5 , 0x03 , 0x31 , 0x19 , 0xf5 , 0x49 , 0xe1 , 0x83 , 0xc7 , 0xff , 
 /*    X ,    Y ,    Z ,  gap ,  gap ,  gap ,  gap ,  gap ,               */    
   0xff , 0x89 , 0x25 , 0xff , 0xff , 0xff , 0xff , 0xff 
 /* after Z the gap is left to insert any special purpose characters      */   
} ;            

const int temptbl[14] = { -500 ,   0 ,  500 , 1000 , 1500 , 2000 , 2500 , 3000 , 3500 , 4000 , 4500 , 5000 , 5500 , 6000 } ;

const int volttbl[14] = { -1341 , -320 , 685 , 1675 , 2650 , 3610 , 4555 , 5485 , 6401 , 7300 , 8185 , 9055 , 9910 , 10750 } ;

static __bank1 unsigned char memaddr1 , memidx ;
static __bank1 unsigned char slavead , length , datbuf[2] ;
static __bank1 unsigned char byte , bitt , count , dlycnt ;

#define CLOCK  RC3
#define ISDAT  RC4

void tmr0isr()
{
   asm("clrwdt") ;   /* WATCHDOG TIMER */
   INTCON &= 0xfb ;  /* CLEAR INTERRUPT FLAG */
   PORTA &= 0xc0 ;   /* DISABLE ALL DIGITS */
   PORTD &= 0xc3 ;   /* DISABLE DIGITS 9 to 12*/
   if(dgtno<4){
   PORTB = ( ( ( seg7[ str[ dgtno ] - '0' ] ) ^ 0xff ) & 0xfe );
   if(((dgtno == gformat) ||( dgtno == (gformat+4) && (!dcpt) ))) RC5 = 1 ; else RC5 = 0 ;
   PORTA |= dgttab[ dgtno ] ;
   }
   if ( kcnt != 250 )
       kcnt++ ;
   else
   {
    if ( ( !kfnd ) && ( RE0 ) )
    {
        kfnd = 1 ; kcode = dgtno ;  kcnt = 0 ;
    }
   }
   dgtno++ ;
   if (dgtno == 5){
   PORTB =  (str[5]  & 0xfe );
   PORTD |= 0x20 ;}
   if ( dgtno == 6 ) dgtno = 0 ;
   intrcnt1++ ;
   if ( intrcnt1 == 100 )
   {
       intrcnt1 = 0 ;
       intrcnt2++ ;
       if ( intrcnt2 & 1 ) adcflg = 1 ;
       if ( intrcnt2 == 10 ){
        calcflag = 1 ;
        intrcnt2 = 0 ;}
   }
   dlycnt-- ;
   if ( !convcomp ){
       conv++ ;
       if ( conv == 200 ) { convcomp = 1 ; sample[chn] = 1 ; }
   }
   else
       conv = 0 ;
}

#define rb0isr()\
{\
   T1CON  &= 0xfe ;\
   nsamp = CCPR1H /* TMR1H */ ;\
   nsamp <<= 8 ;\
   nsamp |= CCPR1L /* TMR1L */ ;\
   if ( ( nsamp > sample[chn] - 32 ) && ( nsamp < sample[chn] + 32 ) ){\
        sample[ chn ] = ( ( long ) sample[ chn ] * 7L + ( long ) nsamp ) >> 3 ;\
   }\
   else\
       sample[ chn ] = nsamp ;\
   convcomp = 1 ;\
}

void __interrupt() intpol()
{
   if ( INTCON & 4 ) tmr0isr() ;
} 

void strtbit()
{
   CLOCK = 0 ;
   ISDAT = 1 ;
   CLOCK = 1 ;
   ISDAT = 0 ;
   CLOCK = 0 ;
}

void stopbit()
{
   CLOCK = 0 ;
   ISDAT = 0 ;
   CLOCK = 1 ;
   ISDAT = 1 ;
   CLOCK = 0 ;
}

void databit0()
{
   CLOCK = 0 ;
   ISDAT = 0 ;
   CLOCK = 1 ;
   ISDAT = 0 ;
   CLOCK = 0 ;
}

void databit1()
{
   CLOCK = 0 ;
   ISDAT = 1 ;
   CLOCK = 1 ;
   ISDAT = 1 ;
   CLOCK = 0 ;
}

void bitin()
{
   CLOCK = 0 ;
   ISDAT = 1 ;
   TRISC  |= 0x10 ;
   CLOCK = 1 ;
   TRISC  |= 0x10 ;
   bitt   = ISDAT ;
   TRISC  &= 0xef ;
   CLOCK = 0 ;
}
                /* ADDED FOR TH/C INPUT */

int lin( void )
{
 return(( int )( ( long )( y2 - y1 ) * ( x - x1 ) / ( long )( x2 - x1 ) + y1 ) ) ;
}

int linear()
{
   long slope ;
   slope = ( long ) ( y2 - y1 ) * 10000L ;
   slope /= ( long ) ( x2 - x1 ) ;
   slope *= ( long ) ( x - x1 ) ;
   slope /= 10000L ;
   slope += y1 ;
   return ( ( int ) slope ) ;
}

int mult( char w )
{
  if(typ == 0 ||  typ ==1)
    return( 50 * w - 100 ) ;
  else
    return (500 * w - 1000 );
}

void initptr( void )
{
  if ( typ == 0 )
  {
    asize = 18 ; cntptr = arrj ;
  }
  else if ( typ == 1 )
  {
    asize = 28 ; cntptr = arrk ;
  }
   else if (typ == 2 )
  {
    asize = 20 ; cntptr = arrr ; 
  }
}

int idl( int xx )
{
  static __bank2 char z ;
  initptr() ;
  if( -99 <= xx <= ( mult( asize - 1 ) ) )
  for( z = 0 ; z < asize ; z++ )
  {
     if( mult( z ) >= xx ) break ;         
  }
  if( z == 0) z++ ;
  y1 = cntptr[ z - 1 ] ;    x1 = mult( z - 1 ) ;
  y2 = cntptr[ z ] ;        x2 = mult( z ) ;
  x = xx ;
  return ( lin()  ) ;
}
void getidlrtd()
{
    char i ;
    i = 0 ;
    while ( ( temptbl[i] < zero ) && ( i != 14 ) ) i++ ;
    if ( i != 14 )
    {
       if ( i == 0 ) i = 1 ;
       x1 = temptbl[ i - 1 ] ;
       x2 = temptbl[ i ] ;
       y1 = (volttbl[ i - 1 ] ) ;
       y2 = (volttbl[ i ] );
       x  = zero ;
       idlzr = lin() ;
    }
    else
        idlzr = /*-1341*/ (-269 * 5) ;
    i = 0 ;
    while ( ( temptbl[i] < span ) && ( i != 14 ) ) i++ ;
    if ( i != 14 )
    {
       if ( i == 0 ) i = 1 ;
       x1 = temptbl[ i - 1 ] ;
       x2 = temptbl[ i ] ;
       y1 = (volttbl[ i - 1 ] ) ;
       y2 = (volttbl[ i ] ) ;
       x  = span ;
       idlsp = lin() ;
    }
    else
        idlsp = /*10750*/ (2155 * 5) ;
} 
void getidl( void )
{
 if(typ <= 2)
 {
  idlzr = idl( zero ) ;
  idlsp = idl( span ) ;
 }
}
        /* ADDED FOR TH/C INPUT */
void byteout()
{
   char i ;
   for ( i = 0 ; i != 8 ; i++ )
   {
       if ( byte & 0x80 ) databit1() ; else databit0() ;
       byte <<= 1 ;
   } 
} 

void bytein()
{
   char i ;
   byte = 0 ;
   for ( i = 0 ; i != 8 ; i++ )
   {
       byte <<= 1 ;
       CLOCK = 0 ;
       ISDAT = 1 ;
       TRISC |= 0x10 ;
       CLOCK = 1 ;
       TRISC |= 0x10 ;
       if ( ISDAT ) byte |= 1 ;
       TRISC &= 0xef ;
       CLOCK = 0 ;
   } 
}

void dispnum( int num , char fmt )
//int num ;
//char fmt ;
{
   char i , sign ;
   if ( num < 0 )
   {
       sign = 1 ; num = 0 - num ;
   }
   else
       sign = 0 ;
   for ( i = 3 ; i != 0xff ; i-- )
   {
        if ( ( i == 0 ) && ( sign ) )
        {
            if ( !num ) 
                str[i] = 0x3b ;
            else
                str[i] = 0x3c ;
        }
        else
            str[i] = ( num % 10 ) + '0' ;
        num /= 10 ;
   }
   gformat = fmt ;
}

/*void dispnum1( int num , char fmt )
//int num ;
//char fmt ;
{
   char i ;
    
   for ( i = 7 ; i != 3 ; i-- )
   {
        str[i] = ( num % 10 ) + '0' ;
        num /= 10 ;
   }
   gformat = fmt ;
}

void dispnumo(int num )
//int num ;
{
   char j ;
   for ( j = 10 ; j != 7 ; j-- )
   {
         str[j] = ( num % 10 ) + '0' ;
        num /= 10 ;
   }
}
*/

void dispstr( const char *s )
//const char *s ;
{
   char i ;
   if(!frmflg) gformat = 6 ;
   for ( i = 0 ; i != 4 ; i++ )
   {
        str[i] = *s++ ;
   }
}

void dispstr1( const char *s  )
//const char *s ;
{
   char i ;
   if(!frmflg ) gformat = 6 ;

   for ( i = 0 ; i != 4 ; i++ )
   {
        str[i] = *s++ ;
   }
}

void master()
{
  strtbit() ;
  memidx = 0 ;
  if ( slavead & 1 )
  {
    byte = slavead & 0xfe ;             /* read operation */
    byteout() ;
    bitin() ;
    if ( bitt == 1 )
    {
      stopbit() ;
      return ;
    }
    byte = memaddr1 & 0x00ff ;             
    byteout() ;
    bitin() ;
    if( bitt == 1 )
    {
      stopbit() ;
      return ;
    }
    strtbit() ;
    byte = slavead ;
    byteout() ;
    bitin() ;
    if( bitt == 1 ) 
    {
      stopbit() ;
      return ;
    }
    while ( length ) 
    {
      bytein() ;
      datbuf[memidx] = byte ;
      memaddr1++ ;
      memidx++ ;
      length-- ;
      if ( length ) databit0() ; else databit1() ;
    } 
    stopbit() ;
  }
  else
  {
    count = length ;
    while ( length ) 
    {
        byte = slavead ;             /* write operation */
        byteout() ;
        bitin() ;
        if( bitt == 1 )
        {
            stopbit() ;
            return ;
        }
        byte = memaddr1 & 0x00ff ;             
        byteout() ;
        bitin() ;
        if( bitt == 1 )
        {
            stopbit() ;
            return ;
        }
        while ( length ) 
        {
            byte = datbuf[memidx] ;
            byteout() ;
            bitin() ;
            if ( bitt == 1 )
            {
                stopbit() ;
                return ;
            }
            memaddr1++ ;
            memidx++ ;
            length-- ;
        }  
    }
    stopbit() ;
    count = 2 ;
    do
    {
        dlycnt = 10 ;
        while ( dlycnt ) ;
        count-- ;
    } while ( count ) ;
  }  
}

unsigned int rdword()
{
    unsigned int dat ;

    length = 2 ;
    slavead = 0xa1 ;
    memaddr1 = addr * 2 ;
    master() ;
    dat = datbuf[0] ;
    dat <<= 8 ;
    dat |= datbuf[1] ;

    chksum += dat ;
    addr++ ;
    return dat ;
}

void wrword( unsigned int  dat )
//unsigned int  dat ;
{
    chksum += dat ;
    memaddr1 = addr * 2 ;
    length = 2 ;
    slavead = 0xa0 ;  
    datbuf[0] = dat >> 8 ;
    datbuf[1] = dat & 0xff ;
    master() ;
    addr++ ;
}

void svcopy(char copy )
//char copy ;
{
    addr = copy << 5 ;
    chksum = 0 ;
    wrword((int) frmt ) ; //addr++ ; 
    wrword( prcs ) ; //addr++ ; 
    wrword( zero ) ; //addr++ ; 
    wrword( span ) ; //addr++ ; 
    wrword( adczr ) ; //addr++ ; 
    wrword( adcsp ) ; //addr++ ; 
    wrword( sp1 ) ; //addr++ ; 
    wrword( sp2 ) ; //addr++ ; 
    wrword( hyst ) ; //addr++ ; 
    wrword((int) rlytp ) ; //addr++ ;
    wrword( cnt4ma ) ; //addr++ ;
    wrword( cnt20ma ) ; //addr++ ;
    wrword( (int)typ )  ;
    wrword(prcs);
    wrword( roomcnt ) ;
    wrword( roomtmp )  ;
    wrword( sp3 )  ;
    wrword( sp4 ) ;
	wrword(rtadj);
    chksum = 0x5555 - chksum ;
    wrword( chksum ) ;
}

void rccopy(char copy )
//char copy ;
{
    addr = copy << 5 ;
    chksum = 0 ;
    frmt = rdword() ; //addr++ ; 
    prcs = rdword() ; //addr++ ; 
    zero = rdword() ; //addr++ ; 
    span = rdword() ; //addr++ ; 
    adczr = rdword() ; //addr++ ; 
    adcsp = rdword() ; //addr++ ; 
    sp1 = rdword() ; //addr++ ; 
    sp2 = rdword() ; //addr++ ; 
    hyst = rdword() ; //addr++ ; 
    rlytp = rdword() ; //addr++ ;
    cnt4ma = rdword() ; //addr++ ;
    cnt20ma = rdword() ; //addr++ ;
    typ = rdword() ;
    prcs = rdword();
    roomcnt = rdword() ;
    roomtmp = rdword() ;

    sp3 = rdword() ; //addr++ ;
    sp4 = rdword() ;
	rtadj=rdword();
    rdword() ;

}

void getidl1()
{
    if(typ == 3  )
    {
      idlzr= 3940  ;
      idlsp= 19525 ;
    }
    if(typ == 4  )
    {
      idlzr= 0  ;
      idlsp= 19725 ;
    }
} 

#define setdefa(){\
    frmt = 2;\
    zero = 0 ;\
    span = 1000 ;\
    adczr = 800 * 5 ;\
    adcsp = 3950 * 5  ;\
    sp1   = 750 ;\
    sp2   = 250 ;\
    rlytp = 0 ;\
    hyst  = 20 ;\
    cnt4ma = 80 ;\
    cnt20ma = 760 ;\
    typ = 2;\
    prcs = 0;\
    sp3 = 200;\
    sp4 = 100 ;\
	rtadj=0;\
}

#define setpar()\
{\
    svcopy( 0 ) ;\
    svcopy( 1 ) ;\
    svcopy( 2 ) ;\
    svcopy( 3 ) ;\
    getidl() ;\
} 


#define getpar()\
{\
    goodcopy = 4 ;\
    for ( copy = 0 ; copy != 4 ; copy++ )\
    {\
	rccopy( copy ) ;\
             achksum[ copy ] = chksum ;\
	if ( chksum == 0x5555 ) goodcopy = copy ;\
    }\
    if ( goodcopy == 4 )\
    {\
	setdefa() ;\
	setpar() ;\
    }\
    else\
    {\
	rccopy( goodcopy ) ;\
	for ( copy = 0 ; copy != 4 ; copy++ )\
	{\
		if ( achksum[ copy ] != 0x5555 )\
		{\
			svcopy( copy ) ;\
		}\
	}\
    }\
    getidl() ;\
}


/*#define getpar()\
{\
    rccopy( 0 ) ;\
    if ( chksum == 0x5555 ){\
        rccopy( 1 ) ;\
        if ( chksum != 0x5555 ){\
            rccopy( 0 ) ;\
            svcopy( 1 ) ;\
        }\
    }\
    else{\
        rccopy( 1 ) ;\
        if ( chksum == 0x5555 )\
            svcopy( 0 ) ;\
        else{\
            setdefa() ;\
            setpar() ;\
        }\
    }\
    getidl() ;\
}*/


void inithw()
{
   INTCON = 0 ;
   PIE1   = 0 ;
   PIE2   = 0 ;
//   OPTION_REG = 0x81 ; /* tmr0 interrupt at 1.024 mS at 4 Mhz crystal */
//   PCON   = 0 ;
   ADCON1 = 0x07 ; /* RA0-RA3 dig.ip/op RD4-RD6 dig.ip/op RD7 anlg input */

   PORTA  = 0x10 ; 
   TRISA  = 0x10 ; /* PORT RA4 AS Keyb I/P RA0-1-2-3 Digit Sel O/P RA5 Relay O/P */

   PORTA  = 0x00 ; 
   TRISA  = 0x00 ;
   
   PORTB  = 0x00 ; 
   TRISB  = 0x00 ; /* ALL PINS AS O/P  */
		 
   PORTC  = 0x04 ; 
   TRISC  = 0x04 ; /* 
   		      ALL PINS AS O/P
                      RC0 4051 Select
                      RC1 PWM 
                      RC2 ADC Ramp Start ( SOC )
                      RC3 SCL
                      RC4 SDA
                      RC5 Decimal Point
                      RC6 Output Relay 1
                      RC7 Output Relay 2 
                      I2C - pins 3 and 4 
                   */

   PORTD = 0x00;
   TRISD = 0x00;

   PORTE = 0x01; /*all output olny bit 0 as key rtn */
   TRISE = 0x01;
          
   TMR1H = 0 ;
   TMR1L = 0 ;
   T1CON = 0x10 ;      /* Timer 1 prescalar = 1 : 2 */
   CCPR1L = 0xff ;
   CCPR1H = 0xff ;
   CCPR2L = 0xff ;
   CCPR2H = 0xff ;
   PIR1 = 0 ;          /* all interrupt flags cleared */
   PIR2 = 0 ;
   INTCON = 0 ;     
//   PCON = 0 ;
   CCP1CON = 0x04 ;

   PR2     = 0xff ;
   CCPR2L  = 0xff ;
   CCP2CON = 0x1c ;
   T2CON   = 0x04 ;
   INTCON = 0xa0 ;    /* global , tmr0 interrupts enabled */
}

void smldly()
{
   char i , j ;

   for ( j = 0 ; j != 4 ; j++ )
       for ( i = 0 ; i != 0x7f ; i++ ) ;
}

void soc()
{
   RE2 = 1 ;
   smldly() ;
   T1CON &= 0xfe ; 
   TMR1H = 0 ;
   TMR1L = 0 ;
   convcomp = 0 ;
   T1CON |= 0x01 ;
    RE2 = 0 ;
   smldly() ;
}

int getnum(int num , int fmt , int lolmt , int hilmt )
{
   char col , sv , sign ;
   int  newnum ;

   col = 0 ;
   dispnum( num , fmt ) ;
   sv = str[ col ] ;
   newnum = num ;
   if ( pwmflag )
   {
       pwmduty = num ;
       CCPR2L  = ( pwmduty & 0x3ff ) >> 2 ;
       CCP2CON = ( pwmduty & 0x3 ) << 4 | 0xc ;
   }
   while ( 1 )
   {
        if ( intrcnt2 & 1 )  
            str[ col ] = sv ;
        else
            str[ col ] = 'X' ;
        if ( kfnd )
        {
              kfnd = 0 ;
              switch ( kcode )
              {
                  case INC : if ( col )
                             {
                                 if ( sv != '9' ) sv++ ; else sv = '0' ;
                             }
                             else
                             {
                                 if ( sv != 0x3c )
                                 {
                                     if ( sv == '9' ) sv++ ;
                                     sv++ ;
                                 }
                                 else
                                     sv = '0' ;
                             } 
                             str[ col ] = sv ;
                             newnum = 0 ;
                             sign = 0 ; 
                             if ( str[ 0 ] == 0x3b ) { newnum = 0 ; sign = 1 ; }
                             else if ( str[ 0 ] == 0x3c ) { newnum = 1 ; sign = 1 ; }
                             else newnum += str[ 0 ] - '0' ;
                             newnum *= 10 ;
                             newnum += str[ 1 ] - '0' ;
                             newnum *= 10 ;
                             newnum += str[ 2 ] - '0' ;
                             newnum *= 10 ;
                             newnum += str[ 3 ] - '0' ;
                             if ( sign ) newnum = 0 - newnum ;
                             if ( pwmflag )
                             {
                                 pwmduty = newnum ;
                                 CCPR2L  = ( pwmduty & 0x3ff ) >> 2 ;
                                 CCP2CON = ( pwmduty & 0x3 ) << 4 | 0xc ;
                             }
                             break ;

                  case DCR : if ( col )
                             {
                                 if ( sv != '0' ) sv-- ; else sv = '9' ;
                             }
                             else
                             {
                                 if ( sv != '0' )
                                 {
                                     if ( sv == '0' ) sv-- ;
                                     sv-- ;
                                 }
                                 else
                                     sv = '9' ;
                             } 
                             str[ col ] = sv ;
                             newnum = 0 ;
                             sign = 0 ; 
                             if ( str[ 0 ] == 0x3b ) { newnum = 0 ; sign = 1 ; }
                             else if ( str[ 0 ] == 0x3c ) { newnum = 1 ; sign = 1 ; }
                             else newnum += str[ 0 ] - '0' ;
                             newnum *= 10 ;
                             newnum += str[ 1 ] - '0' ;
                             newnum *= 10 ;
                             newnum += str[ 2 ] - '0' ;
                             newnum *= 10 ;
                             newnum += str[ 3 ] - '0' ;
                             if ( sign ) newnum = 0 - newnum ;
                             if ( pwmflag )
                             {
                                 pwmduty = newnum ;
                                 CCPR2L  = ( pwmduty & 0x3ff ) >> 2 ;
                                 CCP2CON = ( pwmduty & 0x3 ) << 4 | 0xc ;
                             }
                             break ;



                  case SFT : str[ col ] = sv ;
                             col++ ;
                             if ( col == 4 ) col = 0 ;
                             sv = str[ col ] ;
                             break ;

                  case ENT : str[ col ] = sv ;
                             if ( ( newnum <= hilmt ) && ( newnum >= lolmt ) )
                                 return newnum ;
                             break ;

                  case FUN : dispnum( num , fmt ) ;
                             return num ;

              }
        }
   }
   return num ;
}

void co(void)
{
          chn++ ;
         if(chn==5)
         chn=0;
         switch(chn)
         {
          case 0:  
                 RE1=0;
                 RC0=0;
                 RC6=0;
                 break;
          
          case 1:
                 RE1=1;
                 RC0=0;
                 RC6=0;
                 break;
          case 2: 
                 RE1=1;
                 RC0=1;
                 RC6=0;
                 break;

          case 3: 
                 RE1=0;
                 RC0=0;
                 RC6=1;
                 break;
          case 4: 
                 RE1=1;
                 RC0=0;
                 RC6=1;
                 break;
     }


	
}

int getadc( int idlcnt )
//int idlcnt ;
{
   chn = 0 ;
   while ( 1 )
   {
       if ( adcflg )
       {
          adcflg = 0 ;
//        if ( tuneflag ) autotune() ;
          
          soc() ;
          while  ( !convcomp )
          {
              if ( RC2 == 0 ) rb0isr() ;
          }
         co();          
         // if(p==0)
         // {
          if(!rtflg)
          {
            if ( chn == 0 )
            {	            
               if(typ >=  2)
               {
                 volt = ( ( long ) ( sample[0] - sample[4] ) * 24900L ) / ( long ) ( sample[1] - sample[4] ) ;
                 dispnum( volt / 5 , 0 ) ;
               }
               else
               {
                 volt = ( ( long ) ( sample[0] - sample[4] ) * 4990L ) / ( long ) ( sample[1] - sample[4] ) ;
                 dispnum( volt , 0 ) ;
               }
            }
          }
          else
          {
             volt = ( ( long ) ( sample[2] - sample[4] ) * 5000L ) / ( long ) ( sample[1] - sample[4] ) ;
             dispnum( volt , 0 ) ;
          }
        //  }
        /*  else
          {
                 volt = ( ( long ) ( sample[3] - sample[4] ) * 24900L ) / ( long ) ( sample[1] - sample[4] ) ;
                 dispnum( volt / 5 , 0 ) ;
	          
          }
          
          */
       } 
       if ( kfnd )
       {
              kfnd = 0 ;
              switch ( kcode )
              {
                  case ENT :
                  
                    if(typ != 2)
                    {
                       if ( ( volt > idlcnt - 650 ) && ( volt < idlcnt + 650 ) )
                       {
                         if(typ >= 2)
                           return (volt/5) ;
                         else
                           return  (volt) ;
                       }
                    }
                    else
//                      return (volt / 5 );
                           return  (volt) ;

                                 
                      // break ;

                  case FUN : return -1 ;

              }
       }
   }
   return volt ;
}
/*

int getadc( idlcnt )
int idlcnt ;
{
   chn = 0 ;
   while ( 1 )
   {
       if ( adcflg )
       {
          adcflg = 0 ;
          soc() ;
          while  ( !convcomp )
          {
              if ( RC2 == 0 ) rb0isr() ;
          }
		  co();
         //RB0 = 0 ;
         // chn++ ;
         // chn &= 3 ;
         // if ( chn & 1 ) RE1 = 1 ; else RE1 = 0 ;
         // if ( chn & 2 ) RC0 = 1 ; else RC0 = 0 ;

          if(!rtflg)
          {
            if ( chn == 0 )
            {
               if(typ >=  2)
               {
                 volt = ( ( long ) ( sample[0] - sample[2] ) * 24900L ) / ( long ) ( sample[1] - sample[2] ) ;
                 dispnum( volt / 5 , 0 ) ;
               }
               else
               {
                 volt = ( ( long ) ( sample[0] - sample[2] ) * 4990L ) / ( long ) ( sample[1] - sample[2] ) ;
                 dispnum( volt , 0 ) ;
               }
            }
          }
          else  
          {
             volt = ( ( long ) ( sample[3] - sample[2] ) * 5000L ) / ( long ) ( sample[1] - sample[2] ) ;
             dispnum( volt , 0 ) ;
          }
       } 
       if ( kfnd )
       {
              kfnd = 0 ;
              switch ( kcode )
              {
                  case ENT :
                    if(typ != 2)
                    {
                       if ( ( volt > idlcnt - 650 ) && ( volt < idlcnt + 650 ) )
                       {
                         if(typ >= 2)
                           return (volt/5) ;
                         else
                           return  (volt) ;
                       }
                    }
                    else
                      return (volt / 5 );
                       break ;

                  case FUN : return -1 ;

              }
       }
   }
   return volt ;
}
*/
char getchoice(char ch , char maxch , const char *p )
//char ch , maxch ;
//const char *p ;
{
   char newch ;
   dispstr( p + ( 4 * ch ) ) ;
   newch = ch ;
   if(frmflg)
     gformat = newch ;
   while ( 1 )
   {
        if ( kfnd )
        {
              kfnd = 0 ;
              switch ( kcode )
              {
                  case INC : newch++ ;
                             if ( newch == maxch ) newch = 0 ;
                               dispstr( p + ( 4 * newch ) ) ;
                             if(frmflg)
                               gformat = newch ;
                             break ;
                  case ENT : return newch ;
                  case FUN : dispstr( p + ( 4 * ch ) ) ;
                             return ch ;
              }
        }
   }
   return ch ;
}

/*char getchoice1( char ch , char maxch , const char *p )
//char ch , maxch ;
//const char *p ;
{
   char newch ;
   dispstr( p + ( 4 * ch ) ) ;
   newch = ch ;
   if(frmflg)
     gformat = newch ;
   while ( 1 )
   {
        if ( kfnd )
        {
              kfnd = 0 ;
              switch ( kcode )
              {
                  case INC : newch++ ;
                             if ( newch == maxch ) newch = 0 ;
                               dispstr( p + ( 4 * newch ) ) ;
                             if(frmflg)
                               gformat = newch ;
                             break ;
                  case ATMN: return newch ;
                  case FUN : dispstr( p + ( 4 * ch ) ) ;
                             return ch ;
              }
        }
   }
   return ch ;
}
*/
void dly1sec()
{
   do
   {
       while ( !kfnd ) ;
       kfnd = 0 ;
   } while ( kcode != ENT ) ;
} 

void pgmmode()
{
   dcpt =1 ;
   dispstr1( "ALTP" ) ;
   dly1sec() ;
   rlytp = getchoice( rlytp , 5 , "HHHHHHHLHHLLHLLLLLLL" ) ;
   dispstr1( "SP1X" ) ;
   dly1sec() ;
   sp1 = getnum( sp1 , frmt , zero , span ) ;
   dispstr1( "SP2X" ) ;
   dly1sec() ;
   sp2 = getnum( sp2 , frmt , zero , sp1 ) ;
   dispstr1( "SP3X" ) ;
   dly1sec() ;
   sp3 = getnum( sp3 , frmt , zero , sp2 ) ;
   dispstr1( "SP4X" ) ;
   dly1sec() ;
   sp4 = getnum( sp4 , frmt , zero , sp3 ) ;
   
   dispstr1( "HYST" ) ;
   dly1sec() ;
   hyst = getnum( hyst , frmt , 0 , 100 ) ;
   dcpt = 0 ;
}

unsigned int sqrt(long num) 
//long num ;
{
   long numx,asum1,asum2,unmask,mask,asumsqr;
   char cnt;
   unsigned int  squrt;

   numx = num * 10000L;
   asum1= 0x00008000L;
   asum2= asum1;
   unmask=asum1;
   mask= ~unmask;
   asumsqr = asum1 * asum1;

   for (cnt=0;( cnt != 16 ) && ( asumsqr != numx) ;cnt++)
   {
     if (asumsqr > numx)
       asum1 &= mask;
     unmask>>=1;
     asum1|=unmask;
     mask=~unmask;
     asumsqr = asum1 * asum1;
   }
   squrt=(unsigned int)asum1;
   return squrt ;
 }
int calcrtd() 
{
   char segment ,i;
   int  temp1 ;
    i = 0 ;
    while ( ( temptbl[i] < zero ) && ( i != 14 ) ) i++ ;
    if ( i != 14 )
    {
       if ( i == 0 ) i = 1 ;
       x1 = temptbl[ i - 1 ] ;
       x2 = temptbl[ i ] ;
       y1 = (volttbl[ i - 1 ] ) ;
       y2 = (volttbl[ i ] );
       x  = zero ;
       idlzr = lin() ;
    }
    else
        idlzr =  (-269 * 5) ;
   
    i = 0 ;
    while ( ( temptbl[i] < span ) && ( i != 14 ) ) i++ ;
    if ( i != 14 )
    {
       if ( i == 0 ) i = 1 ;

       x1 = temptbl[ i - 1 ] ;
       x2 = temptbl[ i ] ;
       y1 = (volttbl[ i - 1 ] ) ;
       y2 = (volttbl[ i ] ) ;
       x  = span ;
       idlsp = lin() ;
    }
    else
        idlsp =  (2155 * 5) ;

    under = 0 ;
    over  = 0 ;i = 0 ;

    x1    = adczr ;
    x2    = adcsp ;
    y1    = idlzr ;
    y2    = idlsp ;
    x     = volt ;
    idlvolt = lin() ;

    if ( idlvolt < idlzr  )
    {
      if ( idlvolt > ( idlzr - 20 ) )
         idlvolt = idlzr ;
      else
      {
         under = 1 ;
         temp1 = 0 ;
      }
   }
   if ( idlvolt > (idlsp + 50 ) )
   {
        if ( idlvolt < ( idlsp + 20 ) )
            idlvolt = idlsp ;
        else
         {
            over = 1 ;
            temp1 = span ;
         }
   }
   segment = 0 ;
   if (!under && !over)
   {
     
     while ( ( idlvolt > ( volttbl[ segment ] )) && ( segment != 13 ) ) segment++ ;
    
     if ( segment == 0 ) segment = 1 ;
     x1    = (volttbl[ segment - 1 ]  );
     x2    = (volttbl[ segment ]  ) ;
     y1    = temptbl[ segment - 1 ] ; 
     y2    = temptbl[ segment ] ;      
     x     = idlvolt ;
     temp1 = lin() ;
 
    }
   
    
   return temp1 ;
}
int cal_rt(void)
{
		int temp;
		temp=rtadj;
 	  y2 = 5000 ;         y1 = 0 ;
       x2 = sample[ 1 ] ;   x1 = sample[ 4 ] ;
       x  = sample[ 2 ] ; 
       rt = lin() ; 
       rt /= 10 ;
       rt -=  ( 273 ) ;
	if(!rtflag1)
		return(rt+rtadj);
	else
	 {
		while(1)
			{
				if(intrcnt2 & 1) dispnum( rt+rtadj,4);
				else dispstr1("XXXX");
				if(kfnd)
				{
				kfnd=0;
					switch(kcode)
					{
					case INC : rtadj +=1; break;
					case SFT : rtadj -=1; break;
					case ENT : return rtadj;
					case FUN : return temp ; 
					}
				}		
			}
	}
return temp;
}

int calc()
{
 static __bank2 char j ;
 static __bank2 int t, av ,temp1/*,v1*/,sqtemp1;

  if( (typ == 3) || (typ == 4)  )
  {
   x1   = adczr ;
   x2   = adcsp ;
   y1   = zero  ;
   y2   = span  ;
   x    = volt/5 ;

   over = under = 0 ;

   temp1 =lin() ;
   
   if(typ == 3) 
   {
   if(prcs)
   {
     x1   = adczr ;
     x2   = adcsp ;
     y1   = 0 ;
     y2   = 10000L ;
     x    = volt/5 ;
     temp1 = linear() ;
     sqtemp1 = sqrt((long) temp1);

     x1   = 0 ;
     x2   = 10000L ;
     y1   = zero ;
     y2   = span ;
     x    = sqtemp1 ;
     temp1 = linear() ;

     if(volt/5 < adczr-5) under = 1 ;
     else if(volt/5 > adcsp+5)over = 1 ;
   }
  } 
 }
  else
  {
   {
      y2 = 5000 ;                 y1 = 0 ;
      x2 = sample[ 1 ] ;          x1 = sample[4] ;
      x  = sample[ 0 ] ;  
      av = lin() ;
     rt=cal_rt();
     initptr() ;

      under = 0 ;
      over = 0 ;

      y2 = idlsp ;
      y1 = idlzr ;  
      x2 = adcsp ;
      x1 = adczr ;  
      x  = av ; 
      av = lin() ;

       if(typ == 2)
       {
          if((volt/5) >(adcsp + 5) ) over  = 1 ;
          if((volt/5) <(adczr - 5) ) under = 1 ;
       }

       initptr() ;

       j = 0 ;
        while ( ( j < asize ) && ( av > *cntptr ) )
        {
           j++ ;  cntptr++ ;
        }

        if ( !j )
        {
           j++ ; cntptr++ ;
        }

         x1 = *(cntptr - 1 ) ;    y1 = mult( j - 1 ) ;
         x2 = *cntptr ;           y2 = mult( j ) ;
         x  = av ;
         t  = lin() ;

       if ( ( typ == 0 ) || ( typ == 1 ) )
            t += rt ;

        temp1 = t ;

   }  
     /*  end  COPIED FROM VVD S/W   */
  }

   if(temp1 > span) over = 1 ;
   else if(temp1 < zero ) under = 1 ;
 
   return  temp1 ;
}      

void calmode()
{
   int tmp,pass,minlim,maxlim ;

   dcpt = 1 ;

   dispstr1( "PASS" ) ;
   dly1sec();
   pass = getnum(0, 6 , 0 , 9999 ) ;

  if(pass == 1234 )
  {      
    dispstr1( "INPT" ) ;
    dly1sec();
    typ = getchoice(typ , 4 , "JXTHKXTHXRTDXXMA" ) ;
    
  //  typ = 2 ;
    switch (typ)
    {
     case 0 :                   /*  J TYPE    */
              minlim = -100 ;
              maxlim =  750 ;
              frmt = 8 ;
              break ;
     case 1 :                   /*  K TYPE    */ 
              minlim = -100 ;
              maxlim =  1200 ;
              frmt = 8 ;
              break ;
     case 2 :                   /*  RTD      */
              minlim = -500 ;
              maxlim = 6000 ;
              frmt = 2 ;
              break ;
     case 3 :                   /*  MA      */
              dispstr( "FRMT" ) ;
              frmt = 0 ;
              dly1sec() ;
              frmflg = 1 ;
              frmt = getchoice( frmt , 4 , "XXXXXXXXXXXXXXXX" ) ;
              frmflg = 0 ;
              dispstr( "PRCS" ) ;
              dly1sec() ;
              prcs = getchoice( prcs , 2 , "LINRSQRT" ) ;
              dly1sec() ;
              minlim = -999 ;
              maxlim = 9999 ;
              break ;
    case 4 :                   /*   VLT      */
              dispstr1( "FRMT" ) ;
              dly1sec() ;
              frmflg = 1 ;
              frmt = getchoice( frmt , 4 , "XXXXXXXXXXXXXXXX" ) ;
              frmflg = 0 ;
              minlim = -999 ;
              maxlim = 9999 ;
              break ;
    }
   
    dispstr1( "ZERO" ) ;
    dly1sec() ;
    zero = getnum( zero , frmt  , minlim , maxlim ) ;
    dispstr1( "SPAN" ) ;
    dly1sec() ;
    span = getnum( span , frmt , zero , maxlim ) ;
   
 
	if(typ < 3)
    {
      if(typ == 2)
         getidlrtd();
      else
         getidl() ;
     }
     else
         getidl1() ;

    
    dispstr1( "CAL1" ) ;
    dly1sec() ;
    tmp = getadc( idlzr ) ;
    if ( tmp != -1 ) adczr = tmp ;
    dispstr1( "CAL2" ) ;
    dly1sec() ;
    tmp = getadc( idlsp ) ;
    if ( tmp != -1 ) adcsp = tmp ;

   if(typ<2) temp = calc();  /* ADDED */

    if(typ < 2)
    {
     rtflag1=1;
      dispstr1( "RTMP" ) ;
	  dly1sec() ;
	  rtadj=cal_rt();
	   rtflag1=0;
    }

    dispstr1( "4XMA" ) ;
    dly1sec() ;
    pwmflag = 1 ;
    cnt4ma  = getnum( cnt4ma , 0 , 60 , 200 ) ;
    dispstr1( "20MA" ) ;
    dly1sec() ;
    cnt20ma = getnum( cnt20ma , 0 , 700 , 900 ) ;
    pwmflag = 0 ;
    
    dcpt = 0 ;
  }
}

void r1hi()
{
       if ( temp > sp1 )
           rlystat |= 1 ;
       else
       {
           if ( rlystat & 1 )
           {
               if ( temp < ( sp1 - hyst ) ) 
               {
                   rlystat &= 0xfe ;
               }
           }
       }
}

void r1lo()
{
     if ( temp < sp1 )
         rlystat |= 1 ;
     else
     {
       if ( rlystat & 1 )
       {
          if ( temp > ( sp1 + hyst ) ) 
          {
            rlystat &= 0xfe ;
          }
       }
     }
}

void r2lo()
{
       if ( temp < sp2 )
           rlystat |= 2 ;
       else
       {
           if ( rlystat & 2 )
           {
               if ( temp > ( sp2 + hyst ) ) 
               {
                   rlystat &= 0xfd ;
               }
           }
       }
}

void r2hi()
{ 
       if ( temp > sp2 )
           rlystat |= 2 ;
       else
       {
           if ( rlystat & 2 )
           {
               if ( temp < ( sp2 - hyst ) ) 
               {
                   rlystat &= 0xfd ;
               }
           }
      }
}

void r3lo()
{
       if ( temp < sp3 )
       {
          rlystat |= 4 ;
          str[5] |= 0x80 ;
       }    
       else
       {
           if ( rlystat & 4 )
           {
               if ( temp > ( sp3 + hyst ) ) 
               {
                   rlystat &= 0xfb ;
                   str[5] &= 0x7f ;
               }
           }
       }
}

void r3hi()
{ 
       if ( temp > sp3 )
       {
	   rlystat |= 4 ;
	   str[5] |= 0x80 ;
       }	        
       else
       {
           if ( rlystat & 4 )
           {
               if ( temp < ( sp3 - hyst ) ) 
               {
                   rlystat &= 0xfb ;
                   str[5] &=  0x7f ;
               }
           }
      }
} 


void r4lo()
{
       if ( temp < sp4 )
       {
          rlystat |= 8 ;
          str[5] |= 0x40 ;
       }    
       else
       {
           if ( rlystat & 8 )
           {
               if ( temp > ( sp4 + hyst ) ) 
               {
                   rlystat &= 0xf7 ;
                   str[5] &= 0xbf ;
               }
           }
       }
}

void r4hi()
{ 
       if ( temp > sp4 )
       {
	   rlystat |= 8 ;
	   str[5] |= 0x40 ;
       }	        
       else
       {
           if ( rlystat & 8 )
           {
               if ( temp < ( sp4 - hyst ) ) 
               {
                   rlystat &= 0xf7 ;
                   str[5] &=  0xbf ;
               }
           }
      }
} 


void limit()
{
   if ( rlytp == 0 )        /* HHHH */
   {
       r1hi() ;
       r2hi() ;
       r3hi() ;
       r4hi() ;
   }
   else if ( rlytp == 1 )   /* HHHL */
   {
       r1hi() ;
       r2hi() ;
       r3hi() ;
       r4lo() ;
   }
   else if ( rlytp == 2 )   /* HHLL */
   {
       r1hi() ;
       r2hi() ;
       r3lo() ;
       r4lo() ;
   }
   else if ( rlytp == 3 )   /* HLLL */
   {
       r1hi() ;
       r2lo() ;
       r3lo() ;
       r4lo() ;
   }
   else if ( rlytp == 4 )   /* LLLL */
   {
       r1lo() ;
       r2lo() ;
       r3lo() ;
       r4lo() ;
   }
}

/*--------------------------------------------------------------------------*/
void main()
{
   char mode ;
   int i;
// int good ;
   inithw() ;
   rlystat = 0 ;
   rtflag1=0;
   gformat = 4 ;
   for(i=0;i<=15000;i++)
   {
   dispstr( "NISH" ) ;
   }
  
   getpar() ;

   dcpt = 0 ;

   while ( 1 )
   {
       if ( kfnd )
       {
          kfnd = 0 ;
          if ( kcode == FUN )
          {
              dcpt = 1 ;  
              dispstr1("MODE");
              mode = getchoice( 0 , 2 , "CALMPROG" ) ;
              if ( mode == 0 ) calmode() ;
              else if ( mode == 1 ) pgmmode() ;
              setpar() ;
              dcpt = 0 ;
          }
       }

       if ( adcflg )
       {
          adcflg = 0 ;
          soc() ;
          while  ( !convcomp )
          {
            if ( RC2 == 0 ) rb0isr() ;
          }
          co();          
          if ( chn == 0 )
          {
           if (typ > 1)
           volt = ( ( long ) ( sample[0] - sample[4] ) * 24900L ) / ( long ) ( sample[1] - sample[4] ) ;
           if(typ !=2)	temp = calc() ;
		   else temp=calcrtd();
          }
         } 
           x1   = zero ;
           x2   = span ;
           y1   = cnt4ma ;
           y2   = cnt20ma ;
           x    = temp ;

           if(temp < zero) pwmduty = cnt4ma ;
           else if (temp>span ) pwmduty = cnt20ma ;
           else  pwmduty = lin() ;

           if(pwmduty > cnt20ma) pwmduty = cnt20ma ;
           else if(pwmduty < cnt4ma) pwmduty = cnt4ma ;

           CCPR2L  = ( pwmduty & 0x3ff ) >> 2 ;
           CCP2CON = ( pwmduty & 0x3 ) << 4 | 0xc ;
           limit() ;

           if ( under )dispstr( "UNDR" ) ;
           else if ( over ) dispstr( "OVER" ) ;
           else  dispnum(temp ,frmt) ;
           if ( rlystat & 1 ) RD6 = 1 ; else RD6 = 0 ;
           if ( rlystat & 2 ) RD7 = 1 ; else RD7 = 0 ;
           if ( rlystat & 4 ) RD0 = 1 ; else RD0 = 0 ;
           if ( rlystat & 8 ) RD1 = 1 ; else RD1 = 0 ;
      
           
           
         } 
} 

